/*
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Microsoft.PointOfService;
using System.Reflection; // EventInfo class
*/
using System;
using System.Xml;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Reflection;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.Globalization;
using Microsoft.PointOfService;
using System.Threading;


namespace DialogTest
{
	/// <summary>
	/// PrintAsynchronous   Դϴ.
	/// </summary>
	public class PrintAsynchronousDlg : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// ʼ ̳ Դϴ.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private PosCommon posCommon;
		private PosExplorer posExplorer;
		private PosPrinter	posprinter;
		private System.Windows.Forms.Button button2;
		private PrinterStation CurrentStation = PrinterStation.Receipt;
		private PrintRotation CurrentRotation = PrintRotation.Normal;

		public PrintAsynchronousDlg()
		{
			//
			// Windows Form ̳  ʿմϴ.
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ȣ   ڵ带 ߰մϴ.
			//
			posExplorer = new PosExplorer(this);
			DeviceInfo device = posExplorer.GetDevice("PosPrinter", "Unit1");
			posprinter = (PosPrinter) posExplorer.CreateInstance(device);

			posprinter.Open();
			posprinter.Claim(1000);
			posprinter.DeviceEnabled = true;
			posprinter.AsyncMode = true;

			EventInfo dataEvent = posprinter.GetType().GetEvent( "DataEvent" );
			EventInfo errorEvent = posprinter.GetType().GetEvent( "ErrorEvent" );
			EventInfo outputCompleteEvent = posprinter.GetType().GetEvent( "OutputCompleteEvent" );
			if( dataEvent != null )
				dataEvent.AddEventHandler( posprinter, new DataEventHandler(co_OnDataEvent) );
			if( errorEvent != null )
				errorEvent.AddEventHandler( posprinter, new DeviceErrorEventHandler(co_OnErrorEvent) );
			if( outputCompleteEvent != null )
				outputCompleteEvent.AddEventHandler( posprinter, new OutputCompleteEventHandler(co_OnOutputCompleteEvent) );

			
			EventInfo statusUpdateEvent = posprinter.GetType().GetEvent( "StatusUpdateEvent" );
			EventInfo directIOEvent = posprinter.GetType().GetEvent( "DirectIOEvent " );
			if( statusUpdateEvent != null)
				statusUpdateEvent.AddEventHandler(posprinter, new StatusUpdateEventHandler(co_OnStatusUpdateEvent) );
			if( directIOEvent != null)
				directIOEvent.AddEventHandler(posprinter, new DirectIOEventHandler(co_OnDirectIOEvent) );

			posprinter.SetBitmap(1,CurrentStation, ".\\Logo.bmp", 175, PosPrinter.PrinterBitmapCenter);

		}

		/// <summary>
		///    ҽ մϴ.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}


				posprinter.DeviceEnabled = false;
				posprinter.Release();
				posprinter.Close();
			}
			base.Dispose( disposing );
		}

		#region Windows Form ̳ʿ  ڵ
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(38, 15);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(216, 40);
			this.button1.TabIndex = 2;
			this.button1.Text = "Asynchronous &Print";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(280, 16);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(80, 40);
			this.button2.TabIndex = 3;
			this.button2.Text = "E&xit";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// PrintAsynchronousDlg
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(386, 70);
			this.ControlBox = false;
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "PrintAsynchronousDlg";
			this.Text = "Print Asynchronous Test";
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			try
			{
				string s1, s2, s3, s4;
				s1 = "\x1b|rATEL (123)-456-7890\n\n\n";
				s2 = "\x1b|cAThank you for coming to our shop!\n";
				s3 = "\x1b|cAmmmm/dd/yyyy AM/PM hh:mm\n\n";
				s4 = "\x1b|1B\n\n";

				posprinter.TransactionPrint(CurrentStation, PrinterTransactionControl.Transaction);
				posprinter.PrintNormal(CurrentStation, s4);
				posprinter.PrintNormal(CurrentStation, s1);
				posprinter.PrintNormal(CurrentStation, s2);
				posprinter.PrintNormal(CurrentStation, s3);
				posprinter.PrintNormal(CurrentStation,"Chicken                             $10.00\n");
				posprinter.PrintNormal(CurrentStation,"Hamburger                           $20.00\n");
				posprinter.PrintNormal(CurrentStation,"Pizza                               $30.00\n");
				posprinter.PrintNormal(CurrentStation,"Lemons                              $40.00\n");
				posprinter.PrintNormal(CurrentStation,"Drink                               $50.00\n\n");
				posprinter.PrintNormal(CurrentStation,"Excluded tax                       $150.00\n");
				posprinter.PrintNormal(CurrentStation,"\x1b|uCTax(5%)                              $7.50\n");
				posprinter.PrintNormal(CurrentStation,"\x1b|bC\x1b|2CTotal         $157.50\n\n");
				posprinter.PrintNormal(CurrentStation,"Payment                            $200.00\n");
				posprinter.PrintNormal(CurrentStation,"Change                              $42.50\n\n");
				posprinter.PrintBarCode(CurrentStation, "012345678901", (BarCodeSymbology) BarCodeSymbology.Code39, 40, 2, PosPrinter.PrinterBarCodeCenter, (BarCodeTextPosition) BarCodeTextPosition.Below);
				posprinter.PrintNormal(CurrentStation, "\x1b|fP");
				posprinter.TransactionPrint(CurrentStation, PrinterTransactionControl.Normal);
			}
			catch(Exception ae)
			{
				string ErrorMsg;
				ErrorMsg = string.Format("{0}", ae.ToString());
				MessageBox.Show(ErrorMsg, "POS Printer can't use ", 0);
				button1.Enabled = false;
			}
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			Dispose(true);
		}

		private void co_OnDataEvent(object source, DataEventArgs d)
		{
			// display the data
			string str = d.ToString() + "\r\n";
			MessageBox.Show(str, "DataEvent", 0);
		}

		private void co_OnStatusUpdateEvent(object source, StatusUpdateEventArgs d)
		{
			int	sts;
			bool	ReceiptStatus = true;
			string str = d.ToString();
			sts = d.Status;

			switch(sts) 
			{
				case PosPrinter.StatusCoverOK:
				case PosPrinter.StatusReceiptCoverOK:
					break;
				case PosPrinter.StatusCoverOpen:
				case PosPrinter.StatusReceiptCoverOpen:
					ReceiptStatus = false;
					break;
				case PosPrinter.StatusReceiptEmpty:
					ReceiptStatus = false;
					break;
				case PosPrinter.StatusReceiptPaperOK:
					break;
			}
			button1.Enabled = ReceiptStatus;
		}

		private void co_OnDirectIOEvent(object source, DirectIOEventArgs d)
		{
			string str = d.ToString() + "\r\n";
			MessageBox.Show(str, "DirectIOEvent", 0);
		}

		private void co_OnErrorEvent(object source, DeviceErrorEventArgs d)
		{
			string str = d.ToString();
			MessageBox.Show(str, "ErrorEvent", 0);
		}

		private void co_OnOutputCompleteEvent(object source, OutputCompleteEventArgs d)
		{
			string str = d.ToString();
			MessageBox.Show(str, "OutputCompleteEvent", 0);
		}
	}
}
